name: Test queries

on:
  push:
    branches:
      - "master"
  pull_request:
    branches:
      - "master"

# Cancel any in-progress CI runs for a PR if it is updated
concurrency:
  group: ${{ github.workflow }}-${{ github.event_name == 'pull_request' && github.head_ref || github.sha }}
  cancel-in-progress: true

defaults:
  run:
    shell: bash

jobs:
  check_compilation:
    strategy:
      fail-fast: false
      matrix:
        os: [ubuntu-latest, windows-latest, macos-14]
        cc: [gcc, clang]
        nvim_tag: [stable]
        exclude:
          - os: ubuntu-latest
            cc: clang
            nvim_tag: stable

          - os: macos-14
            cc: gcc
            nvim_tag: stable

          - os: windows-latest
            cc: clang
            nvim_tag: stable

        include:
          - os: windows-latest
            cc: cl
            nvim_tag: nightly

          - os: ubuntu-latest
            cc: gcc
            nvim_tag: nightly

    name: Parser compilation
    runs-on: ${{ matrix.os }}
    env:
      CC: ${{ matrix.cc }}
      NVIM: ${{ matrix.os == 'windows-latest' && 'nvim-win64\\bin\\nvim.exe' || 'nvim' }}
      ALLOWED_INSTALLATION_FAILURES: ${{ matrix.os == 'windows-latest' && 'rnoweb' }}
    steps:
      - uses: actions/checkout@v4
      - uses: tree-sitter/setup-action/cli@v1
      - uses: ilammy/msvc-dev-cmd@v1

      - name: Install and prepare Neovim
        env:
          NVIM_TAG: ${{ matrix.nvim_tag }}
        run: |
          bash ./scripts/ci-install.sh

      - name: Setup Parsers Cache
        id: parsers-cache
        uses: actions/cache@v4
        with:
          path: |
            ./parser/
            ~/AppData/Local/nvim/pack/nvim-treesitter/start/nvim-treesitter/parser/
          key: parsers-${{ join(matrix.*, '-') }}-${{ hashFiles(
            './lockfile.json',
            './lua/nvim-treesitter/install.lua',
            './lua/nvim-treesitter/parsers.lua',
            './lua/nvim-treesitter/shell_command_selectors.lua') }}

      - name: Compile parsers
        run: $NVIM --headless -c "lua require'nvim-treesitter.install'.prefer_git=false" -c "TSInstallSync all" -c "q"

      - name: Post compile Windows
        if: runner.os == 'Windows'
        run: cp -r ~/AppData/Local/nvim/pack/nvim-treesitter/start/nvim-treesitter/parser/* parser

      - name: Check query files
        run: $NVIM -l scripts/check-queries.lua
